SystemOrganization addCategory: #'Oth-chat'!

Object subclass: #Messenger
	instanceVariableNames: 'window container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oth-chat'!

Messenger subclass: #ClientClass
	instanceVariableNames: 'socket hostname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oth-chat'!

!ClientClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/28/2014 11:21'!
connect

	| msgLoop data  |
	
	socket := Socket newTCP.
	hostname:= 'localhost'.
	socket connectTo: (NetNameResolver addressForName: hostname) port: (Othello PORT_NUMBER) waitForConnectionFor: 10.
	
	msgLoop := [
		
		data := 'begin'.
		
		[data ~= 'quit'] whileTrue: [
			
			data := socket receiveData.
			('Client: ', data) crLog.
		
		].
		
		socket sendData: 'quit'.
		data := socket receiveDataTimeout: 5.
		data crLog.
		
		socket closeAndDestroy.
		socket := nil.
	] newProcess.

	msgLoop name: 'Othello Client Process'.
	msgLoop resume.! !

!Messenger methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/28/2014 13:15'!
initialize
|chatMorph ws  |.
super initialize.
chatMorph :=  TextMorph   new.
chatMorph cancelEdits .
chatMorph canChangeText.
chatMorph isAutoFit .

  (ws := WriteStream on: String new).
  ws nextPutAll: 'Mary had a little lamp,'; cr.   
  ws nextPutAll: 'it''s light was white as show;'; cr.   
  ws nextPutAll: 'and everywhere that Mary went;'; cr.   
  ws nextPutAll: 'that lamp was sure to glow.'; cr.   
  chatMorph newContents: (ws contents).
  ws close.   

	window := StandardWindow labelled: 'Chat client'.
	window addMorph: (container := chatMorph) frame: (0@0 corner: 1150@550).
	window openInWorld.
! !

Messenger subclass: #ServerClass
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oth-chat'!

!ServerClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/28/2014 11:22'!
listen

	| connection msgLoop data |
	
	super initialize.
	
	msgLoop := [
		connection := Socket newTCP.
		connection listenOn: (Othello PORT_NUMBER) backlogSize: 100.

		socket := connection waitForAcceptFor: 30.
		connection closeAndDestroy.
		
		data := 'begin'. "initialized to enter loop"
		
		[data ~= 'quit'] whileTrue: [
			data := socket receiveData.
			('Server: ', data) crLog.
			
		].
		
		socket closeAndDestroy.
	] newProcess.

	msgLoop name: 'Othello Server Process'.
	msgLoop resume.

	"TODO: remove
	(Delay forSeconds: 2) wait.
	ClientController new connect: 'localhost'.
	"! !
